from vulture.condorlite import Job, MockLogger


def test_execution(caplog):
    """
    Test execution of the null executable
    """
    log_entries = [
        "000 (4242.000.000)",
        "Job submitted from host: <0.0.0.0:7777>",
        "Job executing on host: <0.0.0.0:7777>",
        "Job terminated.",
        "    Job node: null"
        "    Normal termination (return value 0)"
    ]
    test_job = Job("test/null.condor")
    test_job.execute()
    output = "\n".join([record.message for record in caplog.records])
    assert [entry in output for entry in log_entries]


def test_exec_failed(caplog):
    """
    Test null -e, which will terminate with return value -1
    """
    log_entries = [
        "000 (4242.000.000)",
        "Job submitted from host: <0.0.0.0:7777>",
        "Job executing on host: <0.0.0.0:7777>",
        "Job terminated.",
        "    Job node: null"
        "    Error in execution (return value -1)"
    ]
    test_job = Job("test/null_fail.condor")
    test_job.execute()
    output = "\n".join([record.message for record in caplog.records])
    assert [entry in output for entry in log_entries]
